import {
  PageContainer,
  ProCard,
  ProForm,
  ProFormDependency,
  ProFormSelect,
  ProFormText,
  ProFormUploadDragger,
} from '@ant-design/pro-components';
import { Button, Form, Image, Spin } from 'antd';
import React, { useEffect, useState } from 'react';
// @ts-ignore
import cookie from 'react-cookies';
import { API } from 'types';
const ShowInfoDemo: React.FC = () => {
  const [form] = Form.useForm<API.ModelImage>();
  const [imageUrl, setImageUrl] = useState<string>('');
  // 是否需要加载中
  const [isLoading, setIsLoading] = useState<boolean>(false);
  const [keyNameList, setKeyNameList] = useState<Record<string, any>[]>([]);
  const [initialValues, setInitialValues] = useState<Record<string, any>>({});

  function fetchKeyValueList() {
    setKeyNameList([
      // { label: '证件号码', value: '200100199508081010' },
      // { label: '性别', value: '男' },
    ]);
    // setInitialValues({
    //   cardCode: '200100199508081010',
    //   gender: '男',
    // })
  }
  function doAddField() {
    setKeyNameList([
      {
        label: '证件名称',
        value: '居民身份',
      },
      {
        label: '证件号码',
        value: '511028198702325665',
      },
      {
        label: '姓名',
        value: '杨阳阳',
      },
      {
        label: '性别',
        value: '男',
      },
      {
        label: '出生日期',
        value: '1989-10-21',
      },
    ]);
  }

  useEffect(() => {
    fetchKeyValueList();
  }, []);

  return (
    <div className="showInfoDemo_wrap">
      <Spin tip="正在分析中，请稍候..." fullscreen={true} spinning={isLoading}></Spin>
      <Button type="primary" onClick={doAddField}>
        addField
      </Button>
      <PageContainer>
        <ProCard wrap title={'选择图片'} bodyStyle={{ display: 'flex' }}>
          <div>
            <ProFormUploadDragger
              width={800}
              name="projectFilePath"
              action="/api/v1/common/upload_file/"
              max={1}
              fieldProps={{
                showUploadList: false,
                listType: 'picture-card',
                beforeUpload: (file) => {
                  setIsLoading(true);
                  const reader = new FileReader();
                  reader.onload = (e) => {
                    setImageUrl(e.target?.result as string);
                  };

                  reader.readAsDataURL(file);

                  // 返回 false 可以阻止上传
                  // 返回 Promise 可以异步操作
                  return true;
                },

                maxCount: 1,
                name: 'file',
                // beforeUpload: beforeUploadFile,
                headers: {
                  'X-CSRFToken': cookie.load('csrftoken'),
                },
              }}
            >
              <Image width={800} src={imageUrl} preview={false} />
            </ProFormUploadDragger>

            {/* <Image width={800} height={800} src={imageUrl}>

          </Image> */}
          </div>

          {/* 展示信息 */}
          <div style={{ flex: 1, padding: 20 }}>
            <ProForm
              form={form}
              submitter={
                { render: false } // 隐藏提交按钮
              } // 配置 submitter
            >
              <ProFormSelect
                style={{ width: 160 }}
                fieldProps={{
                  labelInValue: true,
                }}
                options={keyNameList}
                name="name1"
                label="展示数据"
              />
              <ProFormDependency name={['name1']}>
                {({ name1 }) => {
                  if (name1) {
                    form.setFieldValue('activeKey', name1.value);
                    console.log(name1, 'ProFormDependency_name1');
                    return (
                      <ProFormText
                        width={160}
                        label={name1.label}
                        name={'activeKey'}
                        disabled
                        required={false}
                      />
                    );
                  }
                  return <></>;
                }}
              </ProFormDependency>
            </ProForm>
          </div>
        </ProCard>
      </PageContainer>
    </div>
  );
};

export default ShowInfoDemo;
